#include <hidef.h>      /* common defines and macros */
#include <mc9s12c128.h>     /* derivative information */
#include "EmuIO.h"
#pragma LINK_INFO DERIVATIVE "mc9s12c128"

/*
  This program is an example of how to use the EMU_IO libray to
  read and write an 8-bit external address space. For this program
  to work properly as it is, the project board must be set up correctly
  to provide a circuit that provides a valid read location of 0x9c and
  a valid write location of 0xcc with Port T of the chip acting as the
  address/data bus. 
*/
void main(void) {
  unsigned char i, r;
  
  EnableInterrupts;
  
  /* initialize Port T to emulate an address/data bus */
  emu_IO_init();
  
  /* loop through 8-bit address space */
  /* infinite loop since a char overflows from 255 to 0 */
  for(i = 0; i < 256; i++){
    
    /* read a byte from memory location 0x9c */
    r = read_byte(0x9c);
    
    if(i == 0xcc){
      /* write a byte to memory location 0xcc */
      write_byte(i, r);      
    }else{
      /* write a 0 */
      write_byte(i, 0);
    }

  } 
  
}
